*
*	FM-7 EMULATOR "XM7"
*
*	Copyright (C) 1999-2019 ohD(yasushi@tanaka.net)
*	Copyright (C) 2001-2019 Ryu Takegami
*
*	[ {TuVXe ROMZ[o(XM7 V1.1Ή) ]
*
*	Ώۋ@EfBA^CvɉăAZuɃIvVw肷邱
*		-dDISKTYPE=0	360KB(2D)  ʏtH[}bg
*		-dDISKTYPE=1	720KB(2DD) 1gbNtH[}bg
*		-dDISKTYPE=2	720KB(2DD) ʏtH[}bg
*

	if	defined(FBLOADM)
				ORG		$0FE0
	else
				ORG		$1000
	endif

*
*	萔` (CVXe)
*
STACK			EQU		$0F00			* X^bNŏI
BUFFER			EQU		$0F80			* ėpobt@
KANJI_BUF		EQU		$0FE8			* obt@
DISK_BUF		EQU		$2800			* fBXNobt@
SHARED			EQU		$FC80			* LRAM

*
*	萔` (CI/O)
*
KEYDAT			EQU		$FD01			* L[f[^WX^
SUBMODE			EQU		$FD04			* TuVXe[hWX^
SUBSIN			EQU		$FD05			* TuVXeC^tF[XWX^
BANKSEL			EQU		$FD0F			* ROM/RAMZNgWX^
INITDIS			EQU		$FD10			* CjVG[gROM fBZ[uWX^
FDCSTAT			EQU		$FD18			* FDC Xe[^XWX^
FDCCMD			EQU		FDCSTAT			* FDC R}hWX^
FDCTRACK		EQU		$FD19			* FDC gbNWX^
FDCSECTOR		EQU		$FD1A			* FDC ZN^WX^
FDCDATA			EQU		$FD1B			* FDC f[^WX^
FDDSIDE			EQU		$FD1C			* FDD TChWX^
FDDDRIVE		EQU		$FD1D			* FDD hCuWX^
FDDMODE			EQU		$FD1E			* FDD [hWX^
FDDDRQ			EQU		$FD1F			* FDC DRQ/IRQWX^
JSYNCR			EQU		$FD28			* {Tu WX^(R)
JRCBR			EQU		$FD29			* {Tu RCBWX^(R)
JSYNCW			EQU		$FD2A			* {Tu WX^(W)
JRCBW			EQU		$FD2B			* {Tu RCBWX^(W)
MMR				EQU		$FD80			* MMR }bsOWX^
MSGR			EQU		$FD90			* MMR ZOgWX^
MMSR			EQU		$FD93			* MMR [hZNgWX^

*
*	萔` (TuI/O)
*
SUBMODEL4		EQU		$D405			* Tu[hWX^ (L4)
CRTDSP			EQU		$D408			* CRT ON/OFFWX^
VACC			EQU		$D409			* VRAMANZXtO

*
*	萔` ({TuVXe)
*
JSRCBAREA		EQU		$9F00			* CƂRCBʐMGA
JSDICBNK		EQU		$9FFF			* oNWX^

*
*	[NGA`
*
RS_FLAG			EQU		$00			* VAo̓tO
DRIVE			EQU		$01			* ANZXhCu
TRACK			EQU		$02			* ANZXgbN
DRIVE0_T		EQU		$03			* hCu0̃gbN
DRIVE1_T		EQU		$04			* hCu1̃gbN
SIDE			EQU		$05			* ANZXTCh
SECTOR			EQU		$06			* ANZXZN^
SECTORS			EQU		$07			* AZN^
CLUSTER			EQU		$08			* t@C擪NX^
CLUSTERS		EQU		$0A			* g[^NX^(1NX^1KB)
LASTBYTE		EQU		$0C			* ŏINX^̃oCg
COLOR			EQU		$0E			* J[R[h
TYPE			EQU		$0F			* FDCR}h^Cv
C_TRACK			EQU		$10			* JggbN
C_SIDE			EQU		$11			* JgTCh
C_SECTOR		EQU		$12			* JgZN^
C_SECTORS		EQU		$13			* JgZN^
FM77_FLAG		EQU		RS_FLAG		* FM-77tO
L4_FLAG			EQU		COLOR		* 400CtO (L4)

*
*	AZu`
*
M_FM7			EQU		0			* FM-7V[YS@
M_FM77AV		EQU		1			* FM77AVV[YS@
M_FM77AV40		EQU		2			* FM77AV40/EX/SX
D_NORM2D		EQU		0			* 2D (360KB) ʏtH[}bg
D_SKIP2DD		EQU		1			* 2DD(720KB) PgbNtH[}bg
D_NORM2DD		EQU		2			* 2DD(720KB) ʏtH[}bg

*
*	@CMT I/FoRp ]vO
*
	if	defined(FBLOADM)
ENTRY			ORCC	#$50
				LEAX	<START,PCR
				LDU		#$1000
				LDY		#((PRGEND-START)|1)+1
TFRLOOP			LDD		,X++
				STD		,U++
				LEAY	-2,Y
				BNE		TFRLOOP
				JMP		$1000

				ORG		$1000
	endif

*
*	vOX^[g
*
START			BRA		MAIN

*
*	vOwb_
*
HEADER			FCC		/TINY-DOS(mini) for FM-7  /
				FCC		/Copyright 1991-1992,1999 by ohD/
				FCB		$0D,$0A,$00

HEADER2			EQU		*
				FCC		/SAVEJDIC V1.05  /
				FCC		"Copyright 1999 ohD/ 2003-2019 Ryu Takegami"
				FCB		$0D,$0A,$00

*
*	CvO
*
				ORG		START+$80
MAIN			ORCC	#$50
	if	defined(FBLOADM)
				LDS		#STACK
	else
				LEAS	STACK,PCR
	endif

* n[hEFA
				LBSR	INIT
				LBSR	JRESET
				LBSR	FM7_INIT

* N^Cg\
	if	(DISKTYPE==D_NORM2D)||(defined(FBLOADM))
				LEAX	TITLE_MSG,PCR
				LBSR	PUT_STRING
				LEAX	TITLE_MSG2,PCR
				LBSR	PUT_STRING
				LEAX	SPACE_MSG,PCR
				LBSR	PUT_STRING
				LBSR	KEY_SPACE
	endif

* fBXNtH[}bg
				LBSR	DISK_RST
				LBSR	MS_FORMAT

* {TuZ[u
MAINSAVE		LBSR	JSUBMON
				LBSR	DICROM

* (bZ[W\E[v)
				LBSR	JRESET
				LBSR	CLS
				LEAX	COMPLETE_MSG,PCR
				LBSR	PUT_STRING
				BRA		*


*
* 
*
INIT			LEAX	START,PCR
				LEAX	-$100,X
				TFR		X,D
				TFR		A,DP
* [NNA
				CLRA
INIT1			CLR		,X+
				DECA
				BNE		INIT1
* ʏ
				LEAX	SUBINIT_CMD,PCR
				LDB		#$09
				LBSR	SUB_CMD
				LEAX	SUBCONS_CMD,PCR
				LDB		#$02
				LBSR	SUB_CMD
* {ʐMJ[h`FbN
				LBSR	JSUBCHK
				BCC		INIT2
				LEAX	NOTFOUND_MSG,PCR
				LBSR	PUT_STRING
				BRA		*
INIT2			RTS

*--[ ROMZ[o({TuVXe) ]------------------------------------------

*
*	{TuVXeROM
*
JSUBMON			LBSR	CLS
				LEAX	JSUBMON_MSG,PCR
				LBSR	PUT_STRING
				LEAX	JSUBMON_FN,PCR
				LDD		#16
				STD		<CLUSTERS
				LDD		#1024
				STD		<LASTBYTE
				LBSR	FILE_CREATE
				CLRA
				LDX		#$C000
				LDY		#$4000
				LDU		#$4000
				LBSR	JTFR
				LDX		#$4000
				LDU		#16
				LBSR	FILE_WRITE
				RTS

*
*	ROM
*
DICROM			LBSR	CLS
				LEAX	DICROM_MSG,PCR
				LBSR	PUT_STRING
				LEAX	DICROM_FN,PCR
				LDD		#$100
				STD		<CLUSTERS
				LDD		#1024
				STD		<LASTBYTE
				LBSR	FILE_CREATE

* 64񃋁[v
				CLRA
DICROM1			PSHS	A
				LDX		#$A000
				LDY		#$4000
				LDU		#$1000
				LBSR	JTFR
				LDX		#$4000
				LDU		#4
				LBSR	FILE_WRITE
				PULS	A
				INCA
				CMPA	#$40
				BCS		DICROM1
				RTS

*--[ {ʐMJ[h䕔 v1.01  coded by RyuTak 2006/07/01 ]---------------

*
*	{ʐMJ[hF`FbN
*
*	out
*		Cflag=1	J[h݂Ȃ(Ԃ)
*
JSUBCHK			LDA		JSYNCR
				BMI		JCHKNOCARD
				ANDCC	#$FE
				RTS
JCHKNOCARD		ORCC	#$01
				RTS

*
*	{TuVXe~
*
JSUBHALT		PSHS	A
JSUBHALT1		LDA		JSYNCR
				BMI		JSUBHALT1
				CLR		JSYNCW
				PULS	A,PC

*
*	{TuVXen
*
JSUBRUN			PSHS	A
				LDA		#$80
				STA		JSYNCW
				PULS	A,PC

*
*	{TuVXeZbg
*
JRESET			PSHS	A
				LBSR	JSUBHALT
				LDA		#$0C
				STA		JRCBW
				LBSR	JSUBRUN
				PULS	A,PC

*
*	{TuVXeւ̃R}hM
*
JSENDBLK		CLR		JSYNCW
JSENDBLK1		LDA		,X+
				STA		JRCBW
				DECB
				BNE		JSENDBLK1
				LBSR	JSUBRUN
				RTS

*
*	{TuVXẽf[^](yamamoto ver.)
*
*	in
*		A = {TuROMoNio
*		X = {Tu]AhX
*		Y = CCPU ]AhX
*		U = ]TCY(蔲Ȃ̂128oCgPʂ)
*
JTFR			PSHS	D,X,Y,U,CC,DP
				PSHS	A
* YAMAMOTOR}hgp̂߈U_~[R}h𑗐M
				PSHS	X
				LDB		#JDUMMYCMDEND-JDUMMYCMD
				LEAX	JDUMMYCMD,PCR
				LBSR	JSENDBLK
* ]vO𑗐M
				LDB		#JSENDPRGEND-JSENDPRG
				LEAX	JSENDPRG,PCR
				LBSR	JSENDBLK
				PULS	X
* ]v鎫ROMoNioEAhX𑗐M
JTFRLOOP1		LBSR	JSUBHALT
				LDA		,S
				STA		JRCBW
				TFR		X,D
				STA		JRCBW
				STB		JRCBW
				LBSR	JSUBRUN
				LBSR	JSUBHALT
* 128oCgPʂœ]s
				LDB		#128
JTFRLOOP3		LDA		JRCBR
				STA		,Y+
				DECB
				BNE		JTFRLOOP3
				LEAX	128,X
				LEAU	-128,U
				CMPU	#$0000
				BNE		JTFRLOOP1
* ]Xgbv߂𑗐M
				LEAS	1,S
				LBSR	JSUBHALT
				LDA		#$FF
				STA		JRCBW
				LBSR	JSUBRUN
				LBSR	JSUBHALT
				PULS	D,X,Y,U,CC,DP,PC

*
*	NɑM_~[YAMAMOTOR}h
*	  (ȂƈȌYAMAMOTOR}h퓮삵Ȃ)
*
JDUMMYCMD		FCB		$80
				FCC		/YAMAMOTO/
				FCB		$00
JDUMMYCMDEND	EQU		*

*
*	f[^]pvO
*	 ({TuVXe $9E00-ɓ])
*
JSENDPRG		FCB		$80
				FCC		/YAMAMOTO/
				FCB		$01
				FDB		JSRCBAREA+$14
				FDB		$9E00
				FDB		JSENDPRGEND-JSENDPRG1
				FCB		$03
				FDB		$9E00
				FCB		$00
* C̃f[^M҂
JSENDPRG1		CLR		$9FFF
				LDX		#10
JSENDPRG2		MUL
				LEAX	-1,X
				BNE		JSENDPRG2
* Mf[^$FFȂ]Xgbv
* Mf[^$FFȊOȂ炻̃oN(5bit)̃f[^128oCg]
* (ROMȊÖ̗ł̓oN͊֌WȂ)
				LDA		JSRCBAREA
				CMPA	#$FF
				BEQ		JSENDPRG4
				ORA		#$80
				STA		$9FFF
				LDX		JSRCBAREA+1
				LDY		#JSRCBAREA
				LDB		#128
JSENDPRG3		LDA		,X+
				STA		,Y+
				DECB
				BNE		JSENDPRG3
				BRA		JSENDPRG1
* YAMAMOTOR}hAhX𒲐ĎANZX[`ɔ
JSENDPRG4		LDX		#JSRCBAREA+9
				STX		$800C
				JMP		[$FFFE]
JSENDPRGEND		EQU		*

*--[ FM-7 ]-------------------------------------------------------------------

*
*	FM-7 (77`FbNt)
*
FM7_INIT		TST		BANKSEL
				LDD		#$0201
				STA		INITDIS
* u[gROM̗RAMgpł邩mF (gpłȂFM-77)
				STB		MMSR
				LDB		$FE02
				CLR		$FE02
				LDA		$FE02
				STA		<FM77_FLAG
				STB		$FE02
				CLR		MMSR
				RTS

*
*	Xy[X҂
*
KEY_SPACE		EQU		*
KEY_SPACE1		LEAX	INKEY_CMD,PCR
				LDB		#2
				LBSR	SUB_CMD
				LBSR	SUB_HALT
				LDB		#$80
				STB		SHARED
				LDD		SHARED+3
				CLR		SUBSIN
				TSTB
				BEQ		KEY_SPACE1
				CMPA	#$20
				BNE		KEY_SPACE1
				RTS

*
*	Xy[X̓`FbN
*
KEY_CHKSP		LEAX	INKEY_CHK_CMD,PCR
				LDB		#2
				LBSR	SUB_CMD
				LBSR	SUB_HALT
				LDB		#$80
				STB		SHARED
				LDD		SHARED+3
				CLR		SUBSIN
				TSTB
				BEQ		KEY_CHKSP1
				CMPA	#$20
				BNE		KEY_CHKSP1
				FCB		$86
KEY_CHKSP1		CLRA
				RTS

*
*	ʃNA
*
CLS				LEAX	CLS_CMD,PCR
				LDB		#CLS_CMDe-CLS_CMD
				LBRA	SUB_CMD

*
*	TuCPU ʃNAvO
*
CLS_CMD			FCB		$3F,$59,$41,$4D,$41,$55,$43,$48,$49
				FCB		$93,$D3,$8F,$90
*
CLSENT			LDU		#$0000+80*200
				BSR		CLS1
				LDU		#$4000+80*200
				BSR		CLS1
				LDU		#$8000+80*200
CLS1			TST		VACC
				LDB		#100
				PSHS	B
				LDX		#0
				TFR		X,D
				TFR		X,Y
CLS2			PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D
				DEC		,S
				BNE		CLS2
				CLR		VACC
				PULS	B,PC
CLS_CMDe		EQU		*

*--[ TuCPU ]----------------------------------------------------------------

*
*	TuCPU HALT
*
*	USEREG: A
*
SUB_HALT		LDA		SUBSIN
				BMI		SUB_HALT
				LDA		#$80
				STA		SUBSIN
SUB_HALT1		LDA		SUBSIN
				BPL		SUB_HALT1
				RTS

*
*	TuCPU R}ho
*
*	PARAM.: X	R}hf[^($FC82`)
*			B	M
*	USEREG: A,B,X,U
*
SUB_CMD			LBSR	SUB_HALT
* f[^
				LDU		#SHARED
				CLR		,U+
				CLR		,U+
SUB_CMD1		LDA		,X+
				STA		,U+
				DECB
				BNE		SUB_CMD1
* TuCPU s
				CLR		SUBSIN
				RTS

*
*	o (FM-7p,ANKp)
*
*	PARAM.: X	
*	USEREG: A,B,X,U
*
PUT_STRING		EQU		*
PRINT			TFR		X,U
* 𐔂
				CLRB
PRINT0			LEAU	BUFFER,PCR
				LDA		#$03
				CLRB
				STA		,U+
				STB		,U+
PRINT1			LDA		,X+
				TSTA
				BEQ		PRINT2
				STA		,U+
				INCB
				BRA		PRINT1
PRINT2			PSHS	A,X
				LEAX	BUFFER,PCR
				STB		1,X
				INCB
				INCB
				LBSR	SUB_CMD
				PULS	A,X
				RTS

*--[ DOS ]--------------------------------------------------------------------

	include	diskdrv.asm

*--[ DATA ]-------------------------------------------------------------------

*
*	TuCPU R}h (FM-7)
*
SUBINIT_CMD		FCB		$01,$00,40,25,0,25,0,1,0
SUBCONS_CMD		FCB		$0C,$06
INKEY_CMD		FCB		$29,$03
INKEY_CHK_CMD	FCB		$29,$00

*
*	t@Cl[
*
JSUBMON_FN		FCC		/JSUBMON ROM/,0
DICROM_FN		FCC		/DICROM  ROM/,0

*
*	\bZ[W(N)
*
NOTFOUND_MSG	FCB		$11,$02,$12,$04,$0B
				FCC		/Japanese Sub System Unavailable./,0
FORMAT_MSG		FCB		$11,$07,$12,$0A,$09
				FCC		/Disk formatting .../,0
	if	(defined(FBLOADM)||(DISKTYPE==D_NORM2D))
TITLE_MSG		FCB		$11,$07,$12,$04,$06
				FCC		/XM7 ROM SAVE UTILITY for FM77-101/
				FCB		$12,$02,$08
				FCC		"(C) 1999 PI. / 2003-2019 Ryu Takegami",0
TITLE_MSG2		FCB		$11,$04,$12,$06,$10
				FCC		/Set blank disk to drive 0 and/,0
	endif

*
* \bZ[W(ROMZ[u)
*
JSUBMON_MSG		FCB		$11,$07,$12,$03,$09
				FCC		/Saving Japanese Sub Monitor ROM .../,0
DICROM_MSG		FCB		$11,$07,$12,$07,$09
				FCC		/Saving Dictionary ROM .../,0

*
* \bZ[W(G[)
*
NOTREADY_MSG	FCB		$11,$02,$12,$0C,$10
				FCC		/Drive not ready./,0
WRPROTECT_MSG	FCB		$11,$02,$12,$0A,$10
				FCC		/Disk write protected./,0
SEEKERR_MSG		FCB		$11,$02,$12,$0F,$10
				FCC		/Seek error./,0
READERR_MSG		FCB		$11,$02,$12,$0F,$10
				FCC		/Read error./,0
WRITEERR_MSG	FCB		$11,$02,$12,$0F,$10
				FCC		/Write error./,0
SPACE_MSG		FCB		$11,$04,$12,$0D,$12
				FCC		/Push SPACE key./,0
CLEAR_MSG		FCB		$11,$07,$12,$05,$10
				FCC		/                     /
				FCB		$12,$0d,$12
				FCC		/               /,0
COMPLETE_MSG	FCB		$11,$07,$12,$0F,$09
				FCC		/Completed./,0

*
* vOI
*
PRGEND			EQU		*
				END
