/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ AiOpbg ]
 */

#ifndef _apalet_h_
#define _apalet_h_

#if XM7_VER >= 2

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
BOOL FASTCALL apalet_init(void);
										/*  */
void FASTCALL apalet_cleanup(void);
										/* N[Abv */
void FASTCALL apalet_reset(void);
										/* Zbg */
BOOL FASTCALL apalet_readb(WORD addr, BYTE *dat);
										/* ǂݏo */
BOOL FASTCALL apalet_writeb(WORD addr, BYTE dat);
										/*  */
BOOL FASTCALL apalet_save(int fileh);
										/* Z[u */
BOOL FASTCALL apalet_load(int fileh, int ver);
										/* [h */

/*
 *	v[N
 */
extern WORD apalet_no;
										/* pbgio */
extern BYTE apalet_b[4096];
										/* Bx(0-15) */
extern BYTE apalet_r[4096];
										/* Rx(0-15) */
extern BYTE apalet_g[4096];
										/* Gx(0-15) */

#ifdef __cplusplus
}
#endif

#endif	/* XM7_VER >= 2 */
#endif	/* _apalet_h_ */
