/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ Win32API RtBM[V ]
 */

#ifdef _WIN32

#ifndef _w32_cfg_h_
#define _w32_cfg_h_

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
void FASTCALL LoadCfg(void);
										/* ݒ胍[h */
BOOL FASTCALL LoadCfg_DoubleSize(void);
										/* ݒ胍[h(2{gp) */
BOOL FASTCALL LoadCfg_LanguageMode(void);
										/* ݒ胍[h(ꃂ[hp) */
void FASTCALL SaveCfg(void);
										/* ݒZ[u */
void FASTCALL ApplyCfg(void);
										/* ݒKp */
void FASTCALL GetCfg(void);
										/* ݒ擾 */
void FASTCALL SetMachineVersion(void);
										/* @Đݒ */
void FASTCALL OnConfig(HWND hWnd);
										/* ݒ_CAO */
void FASTCALL SetMRUFile(int type, char *string);
										/* MRUZbg */
void FASTCALL SetMRUMedia(int type, int media);
										/* MediaZbg */
void FASTCALL GetMRUFile(int type, int index, char *string, size_t nlen);
										/* MRU擾 */
int FASTCALL GetMRUMedia(int type, int index);
										/* Media擾 */
void FASTCALL DelMRUFile(int type, int index);
										/* MRU폜 */
int FASTCALL GetMRUNum(int type);
										/* MRU擾 */
void FASTCALL SetAllMRUFile(void);
										/* SMRUZbg */

/*
 *	v[N
 */
#ifdef __cplusplus
}
#endif

#endif	/* _w32_cfg_h_ */
#endif	/* _WIN32 */
